<template>
  <textarea
    v-if="type === 'textarea'"
    v-bind="$attrs"
    :placeholder="placeholder"
    :value="computedValue"
    class="form-control"
    @input="onInput"
    rows="3"
  ></textarea>
  <div v-else-if="type === 'date'" class="input-group flex-nowrap">
    <div class="input-group-prepend">
      <span class="input-group-text" id="addon-wrapping">
        <app-icon icon="calendar" />
      </span>
    </div>
    <input
      v-bind="$attrs"
      :placeholder="placeholder"
      :value="computedValue"
      type="date"
      class="form-control"
      @input="onInput"
    />
  </div>
  <input
    v-else
    v-bind="$attrs"
    :placeholder="placeholder"
    :value="computedValue"
    type="text"
    class="form-control"
    @input="onInput"
  />
  <small v-if="false" class="form-text text-muted"
    >We'll never share your email with anyone else.</small
  >
</template>

<script lang="ts">
import dayjs from "dayjs";
import { defineComponent } from "vue";

export default defineComponent({
  props: {
    modelValue: [Number, String, Date],
    type: {
      type: String,
      default: "text",
    },
    placeholder: {
      type: String,
    },
  },
  data() {
    return {
      newValue: this.modelValue,
    };
  },
  computed: {
    computedValue: {
      get(): number | string {
        if (!this.newValue) return "";
        return this.newValue;
      },
      set(value: number | string) {
        if (this.type === "date") {
          this.newValue = dayjs(value).format("YYYY-MM-DD");
        } else {
          this.newValue = value;
        }

        this.$emit("update:modelValue", value);
      },
    },
  },
  watch: {
    modelValue(value) {
      this.computedValue = value;
    },
  },
  methods: {
    onInput(event: InputEvent) {
      const value = (event.target as HTMLInputElement).value;
      this.updateValue(value);
    },
    updateValue(value: number | string) {
      this.computedValue = value;
    },
  },
});
</script>

<style scoped></style>
